' ---------------------------------------------------------------------------
' Script to create a shortcut
' Source: http://msdn.microsoft.com/en-us/library/fywyxt64%28v=vs.85%29.aspx
' ---------------------------------------------------------------------------

' Checks that all required parameters have been specified
If WScript.Arguments.Count < 3 Then
	WScript.Echo "Required parameters:" & vbCrLf & _
	             "- Shortcut file" & vbCrLf & _
	             "- Target path" & vbCrLf & _
	             "- Working directory" & vbCrLf & _
	             "Optional parameters:" & vbCrLf & _
	             "- Arguments" & vbCrLf & _
	             "- Description" & vbCrLf & _
	             "- Icon Location" & vbCrLf & _
	             "- Window Style"
	WScript.Quit
End If

' Gets the required parameters
sLinkFile = WScript.Arguments(0)
sTargetPath = WScript.Arguments(1)
sWorkingDirectory = WScript.Arguments(2)

' Gets the optional parameters
If WScript.Arguments.Count > 3 Then
	sArguments = WScript.Arguments(3)
Else
	sArguments = ""
End If
If WScript.Arguments.Count > 4 Then
	sDescription = WScript.Arguments(4)
Else
	sDescription = ""
End If
If WScript.Arguments.Count > 5 Then
	sIconLocation = WScript.Arguments(5)
Else
	sIconLocation = ""
End If
If WScript.Arguments.Count > 6 Then
	sWindowStyle = WScript.Arguments(6)
Else
	sWindowStyle = ""
End If

' Creates the folder where the shortcut must be stored
Set fs = CreateObject("Scripting.FileSystemObject") 
If Not fs.FolderExists(fs.GetParentFolderName(sLinkFile)) Then
	fs.CreateFolder(fs.GetParentFolderName(sLinkFile))
End If

' Creates the shortcut object
Set shell = CreateObject("WScript.Shell")
Set link = shell.CreateShortcut(sLinkFile)

' Sets the properties of the shortcut
link.TargetPath = sTargetPath
link.WorkingDirectory = sWorkingDirectory
If sArguments <> "" Then
	link.Arguments = sArguments
End If
If sDescription <> "" Then
	link.Description = sDescription
End If
If sIconLocation <> "" Then
	link.IconLocation = sIconLocation
End If
If sWindowStyle <> "" Then
	link.WindowStyle = sWindowStyle
End If

' Saves the shortcut
link.Save
